<h1>{{title}}</h1>

<ng-container *ngIf="(users$ | async) as users; else loading">
  <button *ngIf="!currentUser" (click)="addUser()"> + ADD User</button>

  <fieldset *ngIf="currentUser">
    <legend>
      <span *ngIf="currentUser.id == -1">Create</span>
      <span *ngIf="currentUser.id != -1">Edit</span>
      User
    </legend>

    <div class="field">
      <label for="name">Name:</label>
      <input type="text" id="name" [(ngModel)]="currentUser.name" placeholder="Name">
    </div>
    <div class="field">
      <label for="age">Age:</label>
      <input type="number" id="age" [(ngModel)]="currentUser.age" placeholder="Age">
    </div>

    <div class="buttons">
      <button (click)="save()"> SAVE</button>
      <button (click)="currentUser = undefined"> Cancel</button>
    </div>
  </fieldset>

  <ng-container *ngIf="users.length > 0; else noUsers">
    <table>
      <thead>
        <tr>
          <th>#</th>
          <th>ID</th>
          <th>Name</th>
          <th>Age</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let u of users; let row=index">
          <td>{{row + 1}}</td>
          <td>{{u.id}}</td>
          <td>{{u.name | titlecase}}</td>
          <td>{{u.age}}</td>
          <td>
            <button (click)="editUser(u)">Edit</button>
            <button (click)="deleteUser(u)">Delete</button>
          </td>
        </tr>
      </tbody>
    </table>
  </ng-container>
</ng-container>

<ng-template #noUsers>
  <div>
    Sorry, no users defined!
  </div>
</ng-template>

<ng-template #loading>
  <div>
    Loading users...
  </div>
</ng-template>
